#include <iostream>
#include <iomanip.h>
#include <stdlib.h>

const int N = 2;

class Matriks
{
    public:
        double re[N][N];
        double im[N][N];
        Matriks();
        void identity();
        void nol();
        void printm();
        void conjugate();
        void dagger();
        void kali(float a);
        float retrace();
        Matriks operator + (Matriks m2);
        Matriks operator - (Matriks m2);
        Matriks operator * (Matriks m2);
        //Matriks Matriks::dagr(Matriks m2);
};


class Kompleks
{
    public:
        double re;
        double im;
        Kompleks();
        void isi(float a, float b);
        void print();
        Kompleks operator + (Kompleks k2);
        Kompleks operator * (Kompleks k2);
};

Kompleks::Kompleks()
{
    re = 0;
    im = 0;
}

void Kompleks::isi(float a, float b)
{
    re = a;
    im = b;
}

void Kompleks::print()
{
    if (im < 0){
    cout << re << " " << im << "i" << endl;
    }
    else{
    cout << re << " + " << im << "i" << endl;
    }
}

Kompleks Kompleks::operator + (Kompleks k2)
{
    Kompleks tmp;
    tmp.re = re + k2.re;
    tmp.im = im + k2.im;
    return(tmp);
}

Kompleks Kompleks::operator * (Kompleks k2)
{
    Kompleks tmp;
    tmp.re = re*(k2.re) - im*(k2.im);
    tmp.im = im*(k2.re) + re*(k2.im);
    return(tmp);
}


Matriks::Matriks()
{
    int i,j;
    for (i=0;i<N;i++)
    {
        for (j=0;j<N;j++)
	{
            re[i][j]=0;
            im[i][j]=0;
        }
    }
}

void Matriks::identity()
{
    int i,j;
    for (i=0;i<N;i++)
    {
        for (j=0;j<N;j++)
	{
            re[i][j]=0;
            im[i][j]=0;
        }
    }
    int k;
    for (k=0;k<N;k++)
    {
        re[k][k]=1;
    }
}

void Matriks::nol()
{
    int i,j;
    for (i=0;i<N;i++)
    {
        for (j=0;j<N;j++)
	{
            re[i][j]=0;
            im[i][j]=0;
        }
    }
}


void Matriks::printm()
{
    int i,j;
    cout << setprecision(2);
    cout << setiosflags(ios::fixed);
    for (i=0;i<N;i++)
    {
        for (j=0;j<N;j++)
        {
            if (im[i][j] < 0)
            {
	    	cout << setw(8) << re[i][j] << im[i][j] << "i";
            }
            else
            {
                cout << setw(8) << re[i][j] << "+" << im[i][j] << "i";
            }
	}
	cout << endl;
    }
    cout << resetiosflags(ios::fixed);
    cout << "=========" << endl;
}

void Matriks::conjugate()
{
    int i,j;
    for (i=0;i<N;i++)
    {
        for (j=0;j<N;j++)
	{
            im[i][j]=(-im[i][j]);
        }
    }
}

void Matriks::kali(float a)
{
    int i, j;
    for (i=0;i<N;i++)
    {
        for (j=0;j<N;j++)
        {
            re[i][j]=a*re[i][j];
            im[i][j]=a*im[i][j];
        }
    }
}

float Matriks::retrace()
{
    int i;
    float sum=0;
    for (i=0;i<N;i++)
    {
        sum = sum + re[i][i];
    }
    return sum;
}


void Matriks::dagger()
{
    Matriks tmp;
    int i,j;
    for (i=0;i<N;i++)
    {
        for (j=0;j<N;j++)
	{
            tmp.re[i][j]=re[i][j];
            tmp.im[i][j]=(-im[i][j]);
        }
    }
    for (i=0;i<N;i++)
    {
        for (j=0;j<N;j++)
        {
            re[i][j]=tmp.re[j][i];
            im[i][j]=tmp.im[j][i];
        }
    }
}


Matriks Matriks::operator + (Matriks m2)
{
    int i,j;
    Matriks tmp;
    for (i=0;i<N;i++)
    {
        for (j=0;j<N;j++)
        {
            tmp.re[i][j] = re[i][j] + m2.re[i][j];
            tmp.im[i][j] = im[i][j] + m2.im[i][j];
        }
    }
    return(tmp);
}

Matriks Matriks::operator - (Matriks m2)
{
    int i,j;
    Matriks tmp;
    for (i=0;i<N;i++)
    {
        for (j=0;j<N;j++)
        {
            tmp.re[i][j] = re[i][j] - m2.re[i][j];
            tmp.im[i][j] = im[i][j] - m2.im[i][j];
        }
    }
    return(tmp);
}

Matriks Matriks::operator * (Matriks m2)
{
    int i,j,k;
    Matriks tmp;
    for (i=0;i<N;i++){
        for (j=0;j<N;j++){
            tmp.re[i][j]=0;
            tmp.im[i][j]=0;
        }
    }
    Matriks tmp1;
    Matriks tmp2;
    for (i=0;i<N;i++){
        for (j=0;j<N;j++){
	    for (k=0;k<N;k++){
                    tmp1.re[i][j]+=re[i][k]*m2.re[k][j];
                    tmp2.re[i][j]+=im[i][k]*m2.im[k][j];
		    tmp1.im[i][j]+=re[i][k]*m2.im[k][j];
		    tmp2.im[i][j]+=im[i][k]*m2.re[k][j];
            }
            tmp.re[i][j]=tmp1.re[i][j] - tmp2.re[i][j];
            tmp.im[i][j]=tmp1.im[i][j] + tmp2.im[i][j];
        }
    }
    return(tmp);
}

